=== debian/changelog ===
iceoryx (2.0.5+dfsg-2) unstable; urgency=medium

  * Reformat d/control
  * Build-Depend on architecture-is-64-bit

 -- Timo Röhling <roehling@debian.org>  Thu, 22 Feb 2024 11:53:23 +0100

iceoryx (2.0.5+dfsg-1) unstable; urgency=medium

  * Update upstream homepage
  * New upstream version 2.0.5+dfsg
  * Refresh patches (no functional changes)

 -- Timo Röhling <roehling@debian.org>  Tue, 05 Dec 2023 21:57:28 +0100

iceoryx (2.0.3+dfsg-2) unstable; urgency=medium

  * Force FTBFS on 32-bit architectures.
    Iceoryx has been unsupported on 32-bit architectures
    for some time already, and it seems that even armhf,
    the only 32-bit architecture that did not FTBFS on
    the buildds, is actually broken. (Closes: #1038662)

 -- Timo Röhling <roehling@debian.org>  Fri, 30 Jun 2023 17:33:12 +0200
