=== debian/control ===
Source: iceoryx
Section: libs
Priority: optional
Maintainer: Debian Robotics Team <team+robotics@tracker.debian.org>
Uploaders: Timo Röhling <roehling@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 architecture-is-64-bit,
 cmake,
 libcpptoml-dev,
Build-Depends-Arch:
 libacl1-dev,
 libgmock-dev <!nocheck>,
 libgtest-dev <!nocheck>,
 libncurses-dev,
Build-Depends-Indep:
 doxygen <!nodoc>,
 graphviz <!nodoc>,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://projects.eclipse.org/projects/technology.iceoryx
Vcs-Git: https://salsa.debian.org/robotics-team/iceoryx.git
Vcs-Browser: https://salsa.debian.org/robotics-team/iceoryx
Description: zero-copy inter-process communication
 Iceoryx is an inter-process communication (IPC) middleware for POSIX
 based operating systems. It features shared memory capabilities which
 allow a true zero-copy data transfer.
 .
 Originating from the automotive domain, it is crucial to transfer a huge
 amount of data between multiple processes to realize driver assistance
 systems or automated driving applications. Moreover, the same efficient
 communication mechanism can be applied to a broader range of use cases,
 e.g. in the field of robotics or game development.

Package: iceoryx
Section: net
Architecture: any
Multi-Arch: no
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This package provides the central RouDi daemon and the introspection
 tool for Iceoryx.

Package: libiceoryx-binding-c2
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: C bindings for the ${source:Synopsis} library
 ${source:Extended-Description}
 .
 This library provides the C bindings for Iceoryx.

Package: libiceoryx-binding-c-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 libiceoryx-posh-dev (= ${binary:Version}),
 libiceoryx-hoofs-dev (= ${binary:Version}),
 libiceoryx-binding-c2 (= ${binary:Version}),
Suggests: iceoryx-doc
Description: C bindings for the ${source:Synopsis} library (headers)
 ${source:Extended-Description}
 .
 This package provides the development headers for the C bindings of Iceoryx.

Package: libiceoryx-posh2
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} POSH transport library
 ${source:Extended-Description}
 .
 This package provides the shared memory transport library of Iceoryx.
 POSH stands for "POsix SHared memory".

Package: libiceoryx-posh-roudi2
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} POSH RouDi library
 ${source:Extended-Description}
 .
 This package provides the RouDi-specific shared memory transport of Iceoryx.
 POSH stands for "POsix SHared memory". RouDi is the central management
 daemon for the shared memory transport.

Package: libiceoryx-posh-gateway2
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} POSH gateway library
 ${source:Extended-Description}
 .
 This package provides the POSH gateway library of Iceoryx.
 POSH stands for "POsix SHared memory".

Package: libiceoryx-posh-config2
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} POSH config library
 ${source:Extended-Description}
 .
 This package provides the POSH config library of Iceoryx.
 POSH stands for "POsix SHared memory".

Package: libiceoryx-posh-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 libiceoryx-hoofs-dev (= ${binary:Version}),
 libiceoryx-posh2 (= ${binary:Version}),
 libiceoryx-posh-config2 (= ${binary:Version}),
 libiceoryx-posh-gateway2 (= ${binary:Version}),
 libiceoryx-posh-roudi2 (= ${binary:Version}),
Suggests: iceoryx-doc
Description: ${source:Synopsis} POSH library headers
 ${source:Extended-Description}
 .
 This package provides the development headers for the POSH libraries
 of Iceoryx.
 POSH stands for "POsix SHared memory".

Package: libiceoryx-hoofs2
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} HOOFS library
 ${source:Extended-Description}
 .
 This package provides the low-level utilities library of Iceoryx.
 HOOFS stands for "Handy Objects Optimized For Safety".

Package: libiceoryx-platform2
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} platform library
 ${source:Extended-Description}
 .
 This package provides the platform library of Iceoryx.

Package: libiceoryx-hoofs-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 libiceoryx-platform2 (= ${binary:Version}),
 libiceoryx-hoofs2 (= ${binary:Version}),
Suggests: iceoryx-doc
Description: ${source:Synopsis} HOOFS library headers
 ${source:Extended-Description}
 .
 This package provide the development headers for the low-level
 utilities and platform library of Iceoryx.
 HOOFS stands for "Handy Objects Optimized For Safety".

Package: libiceoryx-introspection2
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} introspection library
 ${source:Extended-Description}
 .
 This package provides the introspection library of Iceoryx.

Package: libiceoryx-introspection-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 libiceoryx-posh-dev (= ${binary:Version}),
 libiceoryx-hoofs-dev (= ${binary:Version}),
 libiceoryx-introspection2 (= ${binary:Version}),
Suggests: iceoryx-doc
Description: ${source:Synopsis} introspection library headers
 ${source:Extended-Description}
 .
 This package provide the development headers for the introspection library of
 Iceoryx.

Package: iceoryx-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: ${source:Synopsis} library documentation
 ${source:Extended-Description}
 .
 This package provides the API documentation for all Iceoryx components.
